//************************************************************
//  University of Patras 
//      Department of Electrical Engineering & Computer Technology
//       
//      Course: Parallel Programming in AI 
//      Week 03: Simple c++ programs using threads
//
//        ex8.cpp: Printing Hello World
//      Author: Evangelos Dermatas
//      v0.1
/*
*********************************************************************
gcc -v: gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 18.04
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:      g++ ex8.c -o ex8 -pthread
Executing:      ./ex8

Output in my Laptop:

Hello from main Hello from Goodnight  00 World World
Hello from main 1 World
Hello from main 2 World
Hello from main 3 World

Hello from Goodnight  5 World
Hello from Goodnight  6 World
Hello from Goodnight  7 World
Hello from Hello from main 8 World
GoodnightHello from main   99 World
 World

*/

// ***************************************
#include <iostream>
#include <thread>

using namespace std ;

int count ;

// ***************************************
void f1(string s)
{
for( count=0 ; count < 10 ; count++ )
	cout<<"Hello from "<< s << "  " << count << " World" << endl ;

}

// ***************************************
int main()
{
thread th1(f1,"Goodnight") ;
//th1.detach() ;

for( count = 0 ; count < 10 ; count++ )
	cout<<"Hello from main "<< count <<" World\n" ;

if( th1.joinable())
	th1.join() ;

return 0 ;
}
